#ifdef _SELF_TEST
#include <stdio.h>
#include <string.h>
#include <stdint.h>

void usart_send_pure(uint8_t K)
{
  printf("%c",K);
}
#endif

uint8_t b64code(uint8_t V)
{
  V &= 63;
  if (V<26) return 'A'+V; V-= 26;
  if (V<26) return 'a'+V; V-= 26;
  if (V<10) return '0'+V; V-= 10;
  if (V<1)  return '+';
  return '/';
}

uint8_t b64val(uint8_t X)
{
  if (X>='A' && X<='Z') return X-'A';
  if (X>='a' && X<='z') return X-'a'+26;
  if (X>='0' && X<='9') return X-'0'+52;
  if (X=='+') return 62;
  if (X=='/') return 63;
  return 0;
}

uint16_t b64_decode(uint8_t *buffer, uint16_t len)
{
  uint8_t bits= 0;
  uint16_t inp, oup,V;

  inp= oup= V= 0;
  while(1)
    if (bits>=8)
    {
      buffer[oup++]= V>>(bits-8);
      bits-= 8;
    }
    else
    {
      if (inp==len) return oup;
      V= (V<<6) | b64val(buffer[inp]);
      bits+= 6;
      inp++;
    }
}

uint16_t b64_encoded_len(uint16_t mlen)
{
  return  (mlen*8+5)/6;
}


void b64_encode_to_serial(uint8_t* buffer, uint16_t len)
{
  uint16_t V;
  uint8_t bits;

  V= bits= 0;
  while(1)
    if (bits>=6)
    {
      usart_send_pure( b64code(V>>(bits-6)) );  
      bits -= 6;
    }
    else
    {
      if (!len)
      {
        if (bits) usart_send_pure( b64code( (V & ((1<<bits)-1)) << (6-bits)) );
        return ;
      }
      V= (V<<8) | buffer[0]; 
      buffer++; 
      len--;
      bits+= 8;
    }
}

#ifdef _SELF_TEST
int main()
{
  uint8_t g[200];
  while(fgets(g,200,stdin))
  {
    int i;
    for(i=0;g[i];i++) if (g[i]=='\n') { g[i]= 0; break; }
    printf("<%s>\n",g);
    if (g[0]=='.')
    {
      printf("[:");
      b64_encode_to_serial(g+1,strlen(g+1));
      printf("]\n");
    }
    else
    {
      i= b64_decode(g+1, strlen(g+1)); g[i+1]= 0;
      printf("[.%s]\n",g+1); 
    }
  }
}
#endif
