#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include "confile.h"

static int makedir(char *dn)
{
  int R;
  R= mkdir(dn, 0700);
  if (!R) return 0;
  if (errno==EEXIST) return 0;
  return 1;
}

static char* config_dir_from_home()
{
  char *H;
  char buf[256];
  H= getenv("HOME");
  if (!H) return NULL;
  sprintf(buf,"%s/.config",H);
  return strdup(buf);
}

char *get_config_file_name(char *prgname,char *fn)
{
  char *CH;
  char buf[256];
  CH= getenv("XDG_CONFIG_HOME");
  if (!CH || access(CH,R_OK|W_OK|X_OK)) 
    CH= config_dir_from_home();
  if (!CH) goto fail;
  strcpy(buf,CH);

  if (makedir(buf)) goto fail;
  strcat(buf,"/"); strcat(buf,prgname);
  if (makedir(buf)) goto fail;
  strcat(buf,"/"); strcat(buf,fn);
  return strdup(buf);
fail:
  sprintf(buf,"%s-%s",prgname,fn);
  return strdup(buf);
}
