
// this command returns a fixed string, just to test out the USB
// connection and stuff.
#define CMD_TEST           1

// sends out a 4-byte command and stores the response from the
// target device. the fifth byte is the index of the response
// byte.
#define CMD_PRG_COMMAND    2

// this command returns the result of the previously executed
// command. This is done in two steps because the USB protocol
// doesn't allow us to read and write in the same transaction
#define CMD_PRG_COMMAND_RESULT   3

// arranges VCC, SCK and RESET lines to start programming the device
#define CMD_ENTER_PRGMODE  4
#define CMD_LEAVE_PRGMODE  5

  // sets the initial address for writing the page buffer
  // or reading from the device
#define CMD_SET_ADDRESS          6
#define CMD_WRITE_PAGEBUFFER     7
#define CMD_READ_FLASH           8

#define CMD_RESET_TARGET         9


/*****************************************************************
 This command returns the number of bytes the board can receive
 from the PC.
 *****************************************************************/
#define CMD_GET_WSIZE           10
#define CMD_GET_RSIZE           11

/*****************************************************************
 Sends to and receives from the target board.
 *****************************************************************/
#define CMD_DIO_SEND         12
#define CMD_DIO_RECV         13


#define CMD_QUEUEPTRS        14
#define CMD_SETSPEED         15
#define CMD_RESETPTRS        16

/*****************************************************************
  This register holds the number of bytes the device can
  accept from the target board. 
 *****************************************************************/
#define DIO_REG_WSIZE     1
/*****************************************************************
  This register holds the number of bytes the device can
  send to the target board.
 *****************************************************************/
#define DIO_REG_RSIZE     2
/*****************************************************************
  For both directions, the same register is read. When you
  write to this register, the written byte goes to the PC
  via the USB link. When you read from it, you get a byte
  sent from the PC.
 *****************************************************************/
#define DIO_REG_BUFFER    3




#define PCOM_ADDR   0x50
