#include "config.h"
#include <avr/io.h>
#include <util/delay.h>
#include "pcom.h"
#include "pins.h"

#define LCD_DATA   (D,5)
#define LCD_CLOCK  (D,6)
#define LCD_RCLOCK (D,7)

#include "lcd.c"

#define LED (C,5)

void hexp(uint8_t K)
{
  const char z[]= "0123456789ABCDEF";
  lcd_print_char(z[K>>4]);
  lcd_print_char(z[K&0xf]);
}

int main()
{
  uint8_t buf[16];
  uint8_t i;
  uint8_t K,D;

  OUTPUT(LED);
  SET(LED);
  _delay_ms(1000);
  CLR(LED);

  lcd_init();
  lcd_print_char('O'); lcd_print_char('K');

  pcom_init();
  while(1)
  {
    K= pcom_recv(buf,16);
    if (K==0) { _delay_ms(100); continue; }
    lcd_clear_display();
    lcd_print_char('R');
    lcd_print_char(':');
    for(i=0;i<K;i++) lcd_print_char(buf[i]);
    for(i=0;i+1<K;i+=2) { D= buf[i]; buf[i]=buf[i+1]; buf[i+1]= D; }
    pcom_send(buf, K);
    continue;
  }
}
